/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * InvulgoTracker
 * Copyright (C) Thomas Andersen 2009 <thomas.1.andersen@gmail.com>
 * 
 * InvulgoTracker is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * InvulgoTracker is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _DAY_H_
#define _DAY_H_

#include <gtk/gtk.h>
#include <libxml/xmlmemory.h>
#include <libxml/parser.h>
#include <libxml/xmlwriter.h>
#include <libxml/encoding.h>
#include <dirent.h>
#include "i-day-load.h"

class Day
{
public:
	Day(gint year, gint month, gint day);
	virtual ~Day();
	void Load(IDayLoad *rec);
	void SaveInit();
        void SaveData(gchar *name, gchar *timeStr, TaskId value);
	void SaveFinal();

	void FindFiles();
	bool FindNext(int &y, int &m, int &d);
protected:

private:
	void ParseTime(IDayLoad *rec, xmlDocPtr doc, xmlNodePtr cur);
	gint year, month, day;
	xmlTextWriterPtr writer;
	xmlDocPtr doc;
	DIR *dir;
};

#endif // _DAY_H_
