/*
 * InvulgoTracker
 * Copyright (C) Thomas Andersen 2009 <thomas.1.andersen@gmail.com>
 * 
 * InvulgoTracker is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * InvulgoTracker is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _DETAIL_VIEW_H_
#define _DETAIL_VIEW_H_

#include <gtk/gtk.h>
#include "i-day-load.h"
#include "task-time.h"
#include "taskid.h"

class DetailView : public IDayLoad
{
public:
    DetailView();
    virtual ~DetailView();
    void Init(GtkWidget *view, gboolean sortable = FALSE);
    void CalcDay(guint year, guint month, guint day, gboolean accumulate = FALSE);
    void Data(gchar *name, gchar *timeStr, TaskId id);
    void AddTask(gchar *taskName, TaskId id, TaskTime tt);
    bool GetFirst(gchar **dateStr, gchar **name, gchar **durationStr);
    bool GetNext(gchar **dateStr, gchar **name, gchar **durationStr);
protected:

private:
    void ColumnClicked(GtkTreeViewColumn *treeViewColumn, gint columnSortId);
    static gint sort_iter_compare_func (GtkTreeModel *model, GtkTreeIter  *a, GtkTreeIter  *b, gpointer userdata);
    static void column_date_clicked(GtkTreeViewColumn *treeviewcolumn, gpointer user_data);
    static void column_title_clicked(GtkTreeViewColumn *treeviewcolumn, gpointer user_data);
    static void column_duration_clicked(GtkTreeViewColumn *treeviewcolumn, gpointer user_data);
    enum
    {
        COL_DATE,
        COL_TITLE,
        COL_ID,
        COL_DURATION,
        NUM_COLS
    };
    enum
    {
        SORT_DATE,
        SORT_TITLE,
        SORT_DURATION
    };

    GtkTreeModel *CreateModel();

    GtkTreeView *view;
    GtkTreeModel *model;
    GtkTreeIter currentIter;
    guint year,month,day;
    TaskTime *prevTime;
    GtkTreeIter prevIter;
};

#endif // _DETAIL_VIEW_H_
