/*
 * InvulgoTracker
 * Copyright (C) Thomas Andersen 2009 <thomas.1.andersen@gmail.com>
 *
 * InvulgoTracker is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * InvulgoTracker is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef RECENTTASKS_H
#define RECENTTASKS_H

#include "taskid.h"
#include <list>

using std::list;

#define RECENTTASKCOUNT 10

class RecentTasks
{
public:
    RecentTasks();
    virtual ~RecentTasks();

    void Add(const TaskId id);
    bool GetFirst(TaskId &id);
    bool GetNext(TaskId &next);
    void Save();
private:
    void Load();
    void AddBack(const TaskId id);
    list<TaskId>    recent;
    list<TaskId>::const_iterator it;
};

#endif // RECENTTASKS_H
