/*
 * InvulgoTracker
 * Copyright (C) Thomas Andersen 2009 <thomas.1.andersen@gmail.com>
 *
 * InvulgoTracker is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * InvulgoTracker is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef TASKID_H
#define TASKID_H

#include <gtk/gtk.h>
#include <string.h>

/**
  * This class encapsulates a task id.
  * A taskid is a unique 10 digit string.
  */
class TaskId
{
public:
    TaskId();
    TaskId(const gchar *id);
    TaskId(const TaskId &ti);
    virtual ~TaskId();

    void Generate();


    operator const gchar *() { return id; }

    TaskId& operator=(const TaskId &rhs);
    bool operator==(const TaskId &other) const { return !strcmp(id, other.id); }
    bool operator!=(const TaskId &other) const { return !(*this == other); }
private:
    void CopyData(const TaskId &ti);
    gchar *id;
};

#endif // TASKID_H
