/*
 * InvulgoTracker
 * Copyright (C) Thomas Andersen 2009 <thomas.1.andersen@gmail.com>
 *
 * InvulgoTracker is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * InvulgoTracker is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef WORKBALANCE_H
#define WORKBALANCE_H

#include "i-day-load.h"
#include "task-time.h"

class WorkBalance : public IDayLoad
{
public:
    WorkBalance(int year, int month, int day);
    virtual ~WorkBalance();

    int GetMonthToDateBalance();
    int GetDayBalance();

    // IDayLoad interface.
    void Data(gchar *name, gchar *timeStr, TaskId id);

private:
    int year;
    int month;
    int day;
    TaskTime totalTime;
    TaskTime *prevTime;

};

#endif // WORKBALANCE_H
